/**************************************************************************
*  Copyright (c) 1997-1999 by Joseph Parrello. All Rights Reserved.       *
*  Sites  : http://www.geocities.com/SiliconValley/Hills/8145 (USA)       *
*           http://JoParrello.freeweb.org (Europe)                        *
*           http://www.freeweb.org/computer/SourceNet/Owl (Italian)       *
*  E-Mail : joparrello@geocities.com, jofrank@geocities.com               *
*                                                                         *
*  Revision:   2.2  (September 1, 1999).                                  *
*                                                                         *
*  Definition of JPFlatComboBox class.                                    *
*                                                                         *
*  Read JPFLTBOX.TXT for use and license.                                 *
*                                                                         *
*  Only for OWL 5.02 and 5.01 users.                                      *
*  OWL and ObjectWindows are trademarks of Borland International.         *
*                                                                         *
*  This class and any related documentation is provided "as is" without   *
*  warranty of any kind, either express or implied, including, without    *
*  limitation, the implied warranties or merchantability, fitness for     *
*  a particular purpose. The entire risk arising out of use or            *
*  performance of this software remains with you.                         *
**************************************************************************/
#if !defined(jpfltbox_h)
#define jpfltbox_h

#if !defined(OWL_COMBOBOX_H)
#include <owl/combobox.h>
#endif
#if !defined(OWL_UIHELPER_H)
#include <owl/uihelper.h>
#endif
#if !defined(OWL_DC_H)
#include <owl/dc.h>
#endif
#if !defined(OWL_TOOLTIP_H)
#include <owl/tooltip.h>
#endif
#if !defined(OWL_GADGETWI_H)
#include <owl/gadgetwi.h>
#endif

//{{TComboBox = JPFlatComboBox}}
class JPFlatComboBox : public TComboBox {
  public:
    JPFlatComboBox(TWindow* parent,
		   int id,
		   int x,
		   int y,
		   int w,
		   int h,
		   uint32 style,
		   uint textLimit,
		   TModule* module = 0,
         bool flatmode = true);
    virtual ~JPFlatComboBox();

//{{JPFlatComboBoxVIRTUAL_BEGIN}}
  public:
    int     SetListBoxWidth(uint newwidth);
    uint    GetListBoxWidth() const;
    void    SetFlatMode(bool enable);
    bool    IsFlatModeEnabled() const;
    void    SetWindowFont(HFONT font, bool redraw);
    virtual TResult EvCommand(uint id, THandle hWndCtl, uint notifyCode);
//{{JPFlatComboBoxVIRTUAL_END}}

//{{JPFlatComboBoxRSP_TBL_BEGIN}}
  protected:
    HWND        hwndEdit;
    bool        MouseInControl;
    int         MaxListWidth;
    bool        IsInWin31;
    int         CurrentEditHeight;
    bool        FlatMode;
    bool        Pressed;
    bool        isEditFocused;

  protected:
    void        RedrawBorder(void);
    void        InsertEditTooltip(HWND hwndEdit);
    HBRUSH      EvCtlColor(HDC hDC, THandle hWndChild, uint ctlType);
    void        CbnCloseUp();
    void        CbnDropDown();
    void        CbnSetFocus();
    void        CbnKillFocus();
    void        CbnSelChange();
    void        EvPaint();
    void        SetupWindow();
    bool        IdleAction(long idleCount);
    string      LoadInternalString(uint itemId);
    void        RetrieveWindowsVersion();
    void        SetEditHeight();
    void        EvEnable(bool enabled);
    void        EvWindowPosChanged(WINDOWPOS far& windowPos);
    void        EvLButtonUp(uint modKeys, TPoint& point);
    //{{JPFlatComboBoxRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(JPFlatComboBox);
};    //{{JPFlatComboBox}}

#endif  // jpfltbox_h sentry.

